GNU logs - #56988, boring messages


Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#56988: Add call-interactively to "never optimize" list for native compilation
Resent-From: Lynn Winebarger <owinebar@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Fri, 05 Aug 2022 01:38:02 +0000
Resent-Message-ID: <handler.56988.B.165966345319955 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: report 56988
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: 56988 <at> debbugs.gnu.org
X-Debbugs-Original-To: bug-gnu-emacs@HIDDEN
Received: via spool by submit <at> debbugs.gnu.org id=B.165966345319955
          (code B ref -1); Fri, 05 Aug 2022 01:38:02 +0000
Received: (at submit) by debbugs.gnu.org; 5 Aug 2022 01:37:33 +0000
Received: from localhost ([127.0.0.1]:55438 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oJmHM-0005Bn-LX
	for submit <at> debbugs.gnu.org; Thu, 04 Aug 2022 21:37:32 -0400
Received: from lists.gnu.org ([209.51.188.17]:33880)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <owinebar@HIDDEN>) id 1oJmHJ-0005Bf-Td
 for submit <at> debbugs.gnu.org; Thu, 04 Aug 2022 21:37:31 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:40118)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <owinebar@HIDDEN>)
 id 1oJmHJ-00087w-NQ
 for bug-gnu-emacs@HIDDEN; Thu, 04 Aug 2022 21:37:29 -0400
Received: from mail-pg1-x52f.google.com ([2607:f8b0:4864:20::52f]:33783)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.90_1) (envelope-from <owinebar@HIDDEN>)
 id 1oJmHI-0000XS-5L
 for bug-gnu-emacs@HIDDEN; Thu, 04 Aug 2022 21:37:29 -0400
Received: by mail-pg1-x52f.google.com with SMTP id l64so1477718pge.0
 for <bug-gnu-emacs@HIDDEN>; Thu, 04 Aug 2022 18:37:27 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=to:subject:message-id:date:from:mime-version:from:to:cc;
 bh=G9sG/uH+ZpX1nmqgFBffgNyj32+GRlhdSip1kyttixE=;
 b=O4o7yTEevvooJs1WhqCOVCQ28DYSESseOv3TV7sSLbn20HZhOCRwK2abFSd57OaehK
 34NGCvN0zw8E8btaCPKAlQ6/iUE01HkptJLMQbwfuB4L/NmBb6DWFq4J1r8ALZi15OpC
 y81PN2wnfKFYoxX0Mxi2WZVFn8QrY+TWest0iNNc30FuUg0PsFxdkLOBToeuhYIKGVy0
 QEp/12ZEq10luyvB8I//otrym7Id98n3EY07/sFKcrS3msc196Ea528vuj2Hk5XKLU1O
 BJXYNPHbOFD6Gd20RL7000d3B0WkB0EMdvuar1+sU8DMQ0AdR0FzHd5tf1sMA49H7maH
 vNEQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=to:subject:message-id:date:from:mime-version:x-gm-message-state
 :from:to:cc;
 bh=G9sG/uH+ZpX1nmqgFBffgNyj32+GRlhdSip1kyttixE=;
 b=qlvng8UbpPuhz51WZBiVeajAt+E7RIIKcf2GT1VK+MwBWitiUqVzVkXyEth6cqz/2L
 BY+6LXl8jcWhTCrJfc4+sZ3bg4S4G6qqP+cD/61Wdrw9BKG9TOPK0ib3atzpBRXLdx/a
 Vc0KxROSP8k5l8w85sUB9TUSfvFOqMML911G8te9xkfWZ9T3mBHZT1idm/9IosMCGW89
 UciBijWQrSFnAKYPiR12aafEnlxKdBHF42BStahn3lhyyXTYrdboRFTi+dBOWTMikYQR
 +VaLFWIa30W5VIvEDrCQ/cHOoeNAI+DrR5WePiE3Bb955twrdHUC2+FgNNGHsaKEQtJR
 CGZw==
X-Gm-Message-State: ACgBeo2tZRmejt0n7bsFSDdD3F2oOrI9PsfS5KsEyRlRM3qy+xwl7yef
 f+CvAmfjhHSlGMo2NOS4y50G6Hni328sw49T6BISZO6q
X-Google-Smtp-Source: AA6agR5AS3Dn3VdyRW+kQEmvrVoYpmbJQ7XTm1j9a5Xq27GJoiwKJFbgGGzT8BVAO8WuRpLm9zEfSs/3rmj/DWObWuA=
X-Received: by 2002:aa7:8892:0:b0:52e:14cb:7e67 with SMTP id
 z18-20020aa78892000000b0052e14cb7e67mr4435571pfe.35.1659663445366; Thu, 04
 Aug 2022 18:37:25 -0700 (PDT)
MIME-Version: 1.0
From: Lynn Winebarger <owinebar@HIDDEN>
Date: Thu, 4 Aug 2022 21:37:13 -0400
Message-ID: <CAM=F=bCXOJ04mw-u5mg=yBYx8yc8Sp16ujNacJf9MtNunT_Y3Q@HIDDEN>
Content-Type: multipart/alternative; boundary="0000000000001b9a3905e574829e"
Received-SPF: pass client-ip=2607:f8b0:4864:20::52f;
 envelope-from=owinebar@HIDDEN; helo=mail-pg1-x52f.google.com
X-Spam_score_int: -20
X-Spam_score: -2.1
X-Spam_bar: --
X-Spam_report: (-2.1 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, FREEMAIL_FROM=0.001,
 HTML_MESSAGE=0.001, RCVD_IN_DNSWL_NONE=-0.0001, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001, T_SCC_BODY_TEXT_LINE=-0.01 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

--0000000000001b9a3905e574829e
Content-Type: text/plain; charset="UTF-8"

Version 28.1:
Since dumping an Emacs with ~500 core libraries in addition to the 100+
from loadup (596 NCUs in the dump), I noticed huge numbers of async jobs
compiling trampolines for call-interactively.  Adding call-interactively -
and funcall-interactively for good measure - to the customization variable
for functions to never optimize, as well as to the hard-coded list in
advice--add-function, then recompiling and dumping resolved the issue.

Lynn

--0000000000001b9a3905e574829e
Content-Type: text/html; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

<div dir=3D"auto"><div dir=3D"auto">Version 28.1:</div>Since dumping an Ema=
cs with ~500 core libraries in addition to the 100+ from loadup (596 NCUs i=
n the dump), I noticed huge numbers of async jobs compiling trampolines for=
 call-interactively.=C2=A0 Adding call-interactively - and funcall-interact=
ively for good measure - to the customization variable for functions to nev=
er optimize, as well as to the hard-coded list in advice--add-function, the=
n recompiling and dumping resolved the issue.<div dir=3D"auto"><br></div><d=
iv dir=3D"auto">Lynn</div><div dir=3D"auto"><br></div></div>

--0000000000001b9a3905e574829e--




Message sent:


Content-Disposition: inline
Content-Transfer-Encoding: quoted-printable
MIME-Version: 1.0
X-Mailer: MIME-tools 5.505 (Entity 5.505)
Content-Type: text/plain; charset=utf-8
X-Loop: help-debbugs@HIDDEN
From: help-debbugs@HIDDEN (GNU bug Tracking System)
To: Lynn Winebarger <owinebar@HIDDEN>
Subject: bug#56988: Acknowledgement (Add call-interactively to "never
 optimize" list for native compilation)
Message-ID: <handler.56988.B.165966345319955.ack <at> debbugs.gnu.org>
References: <CAM=F=bCXOJ04mw-u5mg=yBYx8yc8Sp16ujNacJf9MtNunT_Y3Q@HIDDEN>
X-Gnu-PR-Message: ack 56988
X-Gnu-PR-Package: emacs
Reply-To: 56988 <at> debbugs.gnu.org
Date: Fri, 05 Aug 2022 01:38:02 +0000

Thank you for filing a new bug report with debbugs.gnu.org.

This is an automatically generated reply to let you know your message
has been received.

Your message is being forwarded to the package maintainers and other
interested parties for their attention; they will reply in due course.

Your message has been sent to the package maintainer(s):
 bug-gnu-emacs@HIDDEN

If you wish to submit further information on this problem, please
send it to 56988 <at> debbugs.gnu.org.

Please do not send mail to help-debbugs@HIDDEN unless you wish
to report a problem with the Bug-tracking system.

--=20
56988: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=3D56988
GNU Bug Tracking System
Contact help-debbugs@HIDDEN with problems


Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#56988: Add call-interactively to "never optimize" list for native compilation
Resent-From: Andrea Corallo <akrl@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Fri, 05 Aug 2022 10:08:01 +0000
Resent-Message-ID: <handler.56988.B56988.1659694069988 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 56988
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Lynn Winebarger <owinebar@HIDDEN>
Cc: 56988 <at> debbugs.gnu.org
Received: via spool by 56988-submit <at> debbugs.gnu.org id=B56988.1659694069988
          (code B ref 56988); Fri, 05 Aug 2022 10:08:01 +0000
Received: (at 56988) by debbugs.gnu.org; 5 Aug 2022 10:07:49 +0000
Received: from localhost ([127.0.0.1]:56308 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oJuFB-0000Fs-IA
	for submit <at> debbugs.gnu.org; Fri, 05 Aug 2022 06:07:49 -0400
Received: from mx.sdf.org ([205.166.94.24]:60698)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <akrl@HIDDEN>) id 1oJuF9-0000Fj-DB
 for 56988 <at> debbugs.gnu.org; Fri, 05 Aug 2022 06:07:48 -0400
Received: from ma.sdf.org (ma.sdf.org [205.166.94.33])
 by mx.sdf.org (8.15.2/8.14.5) with ESMTPS id 275A7koS029570
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256 bits) verified NO);
 Fri, 5 Aug 2022 10:07:46 GMT
From: Andrea Corallo <akrl@HIDDEN>
References: <CAM=F=bCXOJ04mw-u5mg=yBYx8yc8Sp16ujNacJf9MtNunT_Y3Q@HIDDEN>
Date: Fri, 05 Aug 2022 10:07:46 +0000
In-Reply-To: <CAM=F=bCXOJ04mw-u5mg=yBYx8yc8Sp16ujNacJf9MtNunT_Y3Q@HIDDEN>
 (Lynn Winebarger's message of "Thu, 4 Aug 2022 21:37:13 -0400")
Message-ID: <xjfedxvj959.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Lynn Winebarger <owinebar@HIDDEN> writes:

> Version 28.1:
> Since dumping an Emacs with ~500 core libraries in addition to the 100+ from loadup (596 NCUs in the dump), I noticed
> huge numbers of async jobs compiling trampolines for call-interactively.  Adding call-interactively - and
> funcall-interactively for good measure - to the customization variable for functions to never optimize, as well as to the
> hard-coded list in advice--add-function, then recompiling and dumping resolved the issue.

Hi Lynn,

I think we want to keep on optimizing `call-interactively' as changing
this policy this could have a negative performance impact in certain
scenarios.

Perhaps should be investigated why on the process you are engineering
this is happening, and modify it so that only one trampoline is
compiled.

Best Regards

  Andrea




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#56988: Add call-interactively to "never optimize" list for native compilation
Resent-From: Lynn Winebarger <owinebar@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Fri, 05 Aug 2022 12:14:02 +0000
Resent-Message-ID: <handler.56988.B56988.165970162722832 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 56988
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Andrea Corallo <akrl@HIDDEN>
Cc: 56988 <at> debbugs.gnu.org
Received: via spool by 56988-submit <at> debbugs.gnu.org id=B56988.165970162722832
          (code B ref 56988); Fri, 05 Aug 2022 12:14:02 +0000
Received: (at 56988) by debbugs.gnu.org; 5 Aug 2022 12:13:47 +0000
Received: from localhost ([127.0.0.1]:56515 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oJwD4-0005w5-UR
	for submit <at> debbugs.gnu.org; Fri, 05 Aug 2022 08:13:47 -0400
Received: from mail-pj1-f54.google.com ([209.85.216.54]:54076)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <owinebar@HIDDEN>) id 1oJwD2-0005vk-K4
 for 56988 <at> debbugs.gnu.org; Fri, 05 Aug 2022 08:13:45 -0400
Received: by mail-pj1-f54.google.com with SMTP id pm17so2584542pjb.3
 for <56988 <at> debbugs.gnu.org>; Fri, 05 Aug 2022 05:13:44 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=cc:to:subject:message-id:date:from:in-reply-to:references
 :mime-version:from:to:cc;
 bh=4A6RecBL3OHh7BwxN5Yug9KVgF0n0toq9szTDbOgbpc=;
 b=H7JxruwVJwbGOeS8P+tfvlIQB19pEGR1uHc1R63u9GsAjBFYPKdKlyrgky0ymcSwf/
 f1HUW7cN++pjt6fqnTgimC0NRvY1mXTQtLCOcpuSUTOwR3VNqys2QXXjhJKhRbgSuAYs
 fDLZI5P1DJ/TUT2mG2wbE4wtuhmO74QtDx0xTO2f6JmLJnDSUMvQDpuIMooDuv3PscHc
 n7JehbEyRzzoeKGOPStj6UtH3dDNqGF7+c0MLc/70QO2zFF69xGUzl+c8JAytKoBCa+G
 9jzZ84LbgLxH0iKTdsCD5RWj/ZlcKsEQxNX0gQxNdasVozCH9t48vHmkfvJNtzRA5t1d
 aX+w==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=cc:to:subject:message-id:date:from:in-reply-to:references
 :mime-version:x-gm-message-state:from:to:cc;
 bh=4A6RecBL3OHh7BwxN5Yug9KVgF0n0toq9szTDbOgbpc=;
 b=cAGljEdVWP+ha62RwuL93yyzqRD5adGyx05TNTL/CUAoGCCKUTXuMcCiCWW+8jqnRG
 n3rkWBazV/hYuVb0xWA9yWBzxHoOQRXDO+4jlN5Ajgs4V5zcbyhgwoWLdiGbsOvkYbom
 JmNP7KnoZJzBVHrk4xIbNhDPo3KMVI9iRRxpalVA+2OuQdSoIRlrnn7s4qfXE/hd7Idn
 VAjpuL6Xw8u4k48XCmTZdwFmTvoLick34Q4AttLoSESdR1uOMHJGCDkbO1dUVECwxn70
 3Q7khmHumvU/rWVwpMcmtxO7e30HxJwKZlshvfLRrh8HIT4b42OBeB1ckfWjEEimRiAg
 xUZA==
X-Gm-Message-State: ACgBeo3XJ8hioyA0Dd6yIXy53J7cofdt88FRxP0ftuaGBu9ODgzTQr4i
 pVjQOreNQWZvcE9BABojAfVZuigtHIORRPCpv6w=
X-Google-Smtp-Source: AA6agR5tblex5Xb23d5qcUIcrTd7Z5D73Hu6F7tR9uFfiuvkCP/Zn4PuhvWZ8FDBYEwTqePsnvZ5HHCWKnqWGxptQBA=
X-Received: by 2002:a17:902:900c:b0:16d:28ad:29e1 with SMTP id
 a12-20020a170902900c00b0016d28ad29e1mr6419055plp.93.1659701618689; Fri, 05
 Aug 2022 05:13:38 -0700 (PDT)
MIME-Version: 1.0
References: <CAM=F=bCXOJ04mw-u5mg=yBYx8yc8Sp16ujNacJf9MtNunT_Y3Q@HIDDEN>
 <xjfedxvj959.fsf@HIDDEN>
In-Reply-To: <xjfedxvj959.fsf@HIDDEN>
From: Lynn Winebarger <owinebar@HIDDEN>
Date: Fri, 5 Aug 2022 08:13:26 -0400
Message-ID: <CAM=F=bD=PerbhyES5Bm_soN3mYvkkoC_BsORQzNUFZYA7T2Gyw@HIDDEN>
Content-Type: multipart/alternative; boundary="0000000000006a4a1905e57d6592"
X-Spam-Score: 0.0 (/)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--0000000000006a4a1905e57d6592
Content-Type: text/plain; charset="UTF-8"

On Fri, Aug 5, 2022, 6:07 AM Andrea Corallo <akrl@HIDDEN> wrote:

> Lynn Winebarger <owinebar@HIDDEN> writes:
>
> > Version 28.1:
> > Since dumping an Emacs with ~500 core libraries in addition to the 100+
> from loadup (596 NCUs in the dump), I noticed
> > huge numbers of async jobs compiling trampolines for
> call-interactively.  Adding call-interactively - and
> > funcall-interactively for good measure - to the customization variable
> for functions to never optimize, as well as to the
> > hard-coded list in advice--add-function, then recompiling and dumping
> resolved the issue.
>
> Hi Lynn,
>
> I think we want to keep on optimizing `call-interactively' as changing
> this policy this could have a negative performance impact in certain
> scenarios.
>
> Perhaps should be investigated why on the process you are engineering
> this is happening, and modify it so that only one trampoline is
> compiled.


Isn't call-interactively only used in the context of requesting user
input?  That would seem unlikely to benefit from optimization.
Something in one those additional core libraries being dumped is adding
advice to call-interactively.  One of the ways it started is by opening
customize on a group that autoloads a library that hasn't been native
compiled.  That starts the async process for the compiler.  This will
happen just running emacs with whatever library is advising
call-interactively in a problematic way in the dump.  It's not part of my
build process unless I use one of those builds with the additional
libraries as the compiler.
I'm noting it as a bug because it will bite anyone who includes these
additional libraries in the dump as a regular user, not because it impacts
my build process.  I know that's not frequently the case now, but it should
be eventually.

Lynn

--0000000000006a4a1905e57d6592
Content-Type: text/html; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

<div dir=3D"auto"><div><div class=3D"gmail_quote"><div dir=3D"ltr" class=3D=
"gmail_attr">On Fri, Aug 5, 2022, 6:07 AM Andrea Corallo &lt;<a href=3D"mai=
lto:akrl@HIDDEN">akrl@HIDDEN</a>&gt; wrote:<br></div><blockquote class=3D=
"gmail_quote" style=3D"margin:0 0 0 .8ex;border-left:1px #ccc solid;padding=
-left:1ex">Lynn Winebarger &lt;<a href=3D"mailto:owinebar@HIDDEN" target=
=3D"_blank" rel=3D"noreferrer">owinebar@HIDDEN</a>&gt; writes:<br>
<br>
&gt; Version 28.1:<br>
&gt; Since dumping an Emacs with ~500 core libraries in addition to the 100=
+ from loadup (596 NCUs in the dump), I noticed<br>
&gt; huge numbers of async jobs compiling trampolines for call-interactivel=
y.=C2=A0 Adding call-interactively - and<br>
&gt; funcall-interactively for good measure - to the customization variable=
 for functions to never optimize, as well as to the<br>
&gt; hard-coded list in advice--add-function, then recompiling and dumping =
resolved the issue.<br>
<br>
Hi Lynn,<br>
<br>
I think we want to keep on optimizing `call-interactively&#39; as changing<=
br>
this policy this could have a negative performance impact in certain<br>
scenarios.<br>
<br>
Perhaps should be investigated why on the process you are engineering<br>
this is happening, and modify it so that only one trampoline is<br>
compiled.</blockquote></div></div><div dir=3D"auto"><br></div><div dir=3D"a=
uto">Isn&#39;t call-interactively only used in the context of requesting us=
er input?=C2=A0 That would seem unlikely to benefit from optimization.</div=
><div dir=3D"auto">Something in one those additional core libraries being d=
umped is adding advice to call-interactively.=C2=A0 One of the ways it star=
ted is by opening customize on a group that autoloads a library that hasn&#=
39;t been native compiled.=C2=A0 That starts the async process for the comp=
iler.=C2=A0 This will happen just running emacs with whatever library is ad=
vising call-interactively in a problematic way in the dump.=C2=A0 It&#39;s =
not part of my build process unless I use one of those builds with the addi=
tional libraries as the compiler.=C2=A0=C2=A0</div><div dir=3D"auto">I&#39;=
m noting it as a bug because it will bite anyone who includes these additio=
nal libraries in the dump as a regular user, not because it impacts my buil=
d process.=C2=A0 I know that&#39;s not frequently the case now, but it shou=
ld be eventually.</div><div dir=3D"auto"><br></div><div dir=3D"auto">Lynn</=
div><div dir=3D"auto"><br></div></div>

--0000000000006a4a1905e57d6592--





Last modified: Fri, 5 Aug 2022 12:15:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.